﻿using System;
using System.Data.SqlClient;
using System.Security.AccessControl;
using System.Security.Principal;
using System.Threading;

class Program
{
    static EventWaitHandle _ewh = new EventWaitHandle(false, EventResetMode.ManualReset);
    static void Main(string[] args)
    {
        Thread t1 = new Thread(threadFunc);
        t1.Start();

        _ewh.WaitOne();

        Console.WriteLine("Opening DB Connection...");
        SqlConnection con = new SqlConnection();
        Console.WriteLine("Opened");
    }

    private static void threadFunc()
    {
        string mutexName = "Global\\.net data provider for sqlserver";

        bool flag;
        MutexSecurity mutexSecurity = new MutexSecurity();
        SecurityIdentifier identity = new SecurityIdentifier(WellKnownSidType.AuthenticatedUserSid, null);
        mutexSecurity.AddAccessRule(new MutexAccessRule(identity, MutexRights.Synchronize | MutexRights.Modify, AccessControlType.Allow));
        using (Mutex mutex = new Mutex(false, mutexName, out flag, mutexSecurity))
        {
            Console.WriteLine("Enter of MUTEX");
            mutex.WaitOne();
            _ewh.Set();

            Thread.Sleep(-1);
            mutex.ReleaseMutex();
        }
        Console.WriteLine("Exit of MUTEX");
    }
}
